String.prototype.UTF8Encode = function()
{
	string = this.replace(/\x0d\x0a/g, "\x0a");
	var output = "";
	for (var n = 0; n < string.length; n++)
	{
		var c = string.charCodeAt(n);
		if (c < 128)
		{
			output += String.fromCharCode(c);
		}
		else if ((c > 127) && (c < 2048))
		{
			output += String.fromCharCode((c >> 6) | 192);
			output += String.fromCharCode((c & 63) | 128);
		}
		else
		{
			output += String.fromCharCode((c >> 12) | 224);
			output += String.fromCharCode(((c >> 6) & 63) | 128);
			output += String.fromCharCode((c & 63) | 128);
		}
	}
	return output;
};

String.prototype.base64Encode = function()
{
	var output = "";
	var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
	var i = 0;
	var input = this.UTF8Encode();
	var keyString = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	while (i < input.length){
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		if (isNaN(chr2))
		{
			enc3 = enc4 = 64;
		}
		else if (isNaN(chr3))
		{
			enc4 = 64;
		}
		output = output + keyString.charAt(enc1) + keyString.charAt(enc2) + keyString.charAt(enc3) + keyString.charAt(enc4);
	}
	return output;
};

String.prototype.removeAccents = function ()
{
	var __r = {
			'\u00C1':'A', '\u00C4':'A',
			'\u00C9':'E', '\u00CB':'E',
			'\u00CD':'I', '\u00CF':'I',
			'\u00D3':'O', '\u00D6':'O',
			'\u00DA':'U', '\u00DC':'U',
			'\u00D1':'N'
			
	};
	return this.replace(/[\u00C1\u00C4\u00C9\u00CB\u00CD\u00CF\u00D3\u00D6\u00DA\u00DC\u00D1]/gi, function(m){

		ret = __r[m.toUpperCase()];
					
		if (m === m.toLowerCase())
			ret = ret.toLowerCase();
			
		return ret;
	});
};

String.prototype.trim = function( extras )
{
	return this.ltrim(extras).rtrim(extras);
}

String.prototype.ltrim = function( extras )
{
	ret = this;
	if ( typeof(extras) != 'undefined' )
	{
		ret = ret.replace( new RegExp('^'+new RegExp(extras).toString().replace(/^[\/\[]|[\/\]]$/ig, '')+'+'), '');
	}
	return ret.replace(/^\s+/,'');
}

String.prototype.rtrim = function( extras )
{
	ret = this;
	if ( typeof(extras) != 'undefined' )
	{
		ret = ret.replace( new RegExp(new RegExp(extras).toString().replace(/^[\/\[]|[\/\]]$/ig, '')+'+$'), '');
	}
	return ret.replace(/\s+$/,'');
}

